include \masm32\include\masm32rt.inc

.data?
hPen          dd ?
hDC           dd ?
DesktopWidth  dd ?
DesktopHeight dd ?
X             dd ?
Y             dd ?
MouseP        POINT <?>
.code

DrawLine PROC DC:dword,x1:dword,y1:dword,x2:dword,y2:dword
    invoke MoveToEx,DC,x1,y1,NULL
    invoke LineTo,DC,x2,y2
    ret
DrawLine endp

start:
    invoke GetDC,NULL
    mov hDC,eax
    mov DesktopWidth,rv(GetDeviceCaps,hDC,HORZRES)
    mov DesktopHeight,rv(GetDeviceCaps,hDC,VERTRES)
    invoke CreatePen,PS_SOLID,4,0
    mov hPen,eax
    invoke SelectObject,hDC,hPen
    push eax
    .While TRUE
        .If rv(GetAsyncKeyState,VK_ESCAPE)>0
            .break
        .Endif
        invoke GetCursorPos,offset MouseP
        mov eax,MouseP.x
        mov esi,MouseP.y
        .If X!=eax || Y!=esi
            invoke RedrawWindow,NULL,NULL,NULL,RDW_INVALIDATE or RDW_ALLCHILDREN
            invoke DrawLine,hDC,0,MouseP.y,MouseP.x,MouseP.y             ;hor Left
            invoke DrawLine,hDC,DesktopWidth,MouseP.y,MouseP.x,MouseP.y  ;hor Right
            invoke DrawLine,hDC,MouseP.x,0,MouseP.x,MouseP.y             ;vert Top
            invoke DrawLine,hDC,MouseP.x,DesktopHeight,MouseP.x,MouseP.y ;vert Bot
        .EndIf
        m2m X,MouseP.x
        m2m Y,MouseP.y
    .EndW
    invoke RedrawWindow,NULL,NULL,NULL,RDW_INVALIDATE or RDW_ALLCHILDREN
    pop eax
    invoke SelectObject,hDC,eax
    invoke DeleteObject,hPen
    INVOKE ReleaseDC,NULL,hDC
    exit
end start